#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "CoreMemorySpawnedStatusEffectTrackerComponent.generated.h"

class UStatusEffect;
class UCoreMemoryImposeStatusEffectBehaviour;
class ACoreMemoryChallengePlayerSpecificController;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class UCoreMemorySpawnedStatusEffectTrackerComponent : public UActorComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(Transient, Export)
	TArray<TWeakObjectPtr<UStatusEffect>> _authority_spawnedStatusEffects;

	UPROPERTY(Transient)
	TWeakObjectPtr<UCoreMemoryImposeStatusEffectBehaviour> _authority_imposeStatusEffectBehaviour;

private:
	UFUNCTION(BlueprintCallable)
	void Authority_AddSpawnedStatusEffect(UStatusEffect* statusEffect, ACoreMemoryChallengePlayerSpecificController* playerController);

public:
	UCoreMemorySpawnedStatusEffectTrackerComponent();
};

FORCEINLINE uint32 GetTypeHash(const UCoreMemorySpawnedStatusEffectTrackerComponent) { return 0; }
